#
# test05.rb
#
# $Id: test05.rb,v 1.1 2000/11/22 14:36:00 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


NP = 14
NX = 73
NY = 37
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = 90
p = NArray.new(Float, NX*NY)

#-- data ---
ctr = ['cyl','mer','mwd','hmr','ek6','ktd','con',
       'coa','coc','bon','otg','pst','azm','aza']
fct = NArray[0.12, 0.12, 0.14, 0.14, 0.14, 0.14, 0.11,
               0.16, 0.12, 0.12, 0.40, 0.12, 0.12, 0.17]

i = 0
File.foreach('t811231.dat') do |line|
  line.split(" ").each do |data|
    p[i] = data.to_f
    i += 1
  end
end
p.reshape(NX, NY)

190.step(245, 5) do |r|
  amin=r
  amax=r+5
#       IDX=(R-180)*1.4*1000+999
  idx=((r-170)*1.25).to_i*1000+999
  uestlv(amin, amax, idx)
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws

sglset('LSOFTF', false)
sgrset('STLAT1', 75.0)
sgrset('STLAT2', 60.0)
umlset('LGRIDMJ', false)
umrset('DGRIDMN', 30.0)

for i in 0..NP-1
  sgfrm
  sgssim(fct[i], 0.0, 0.0)
  sgsmpl(165.0, 60.0, 0.0)
  sgsvpt(0.1, 0.9, 0.1, 0.9)
  sgswnd(XMIN, XMAX, YMIN, YMAX)

  if (ctr[i] == 'otg')
    sgstxy(-180.0, 180.0, 0.0, 90.0)
  else
    sgstxy(-180.0, 180.0, -90.0, 90.0)
  end
  sgstrn(isgtrc(ctr[i]))
  sgstrf

  sglset('LCLIP', true)
  slpwwr(1)
  slpvpr(1)
  cttl = sgtrnl(isgtrc(ctr[i]))
  sgtxzr(0.5, 0.95, cttl, 0.03, 0, 0, 3)

  uetone(p, NX, NX, NY)
  udcntr(p, NX, NX, NY)
  umpmap('coast_world')
  umpglb
  slpvpr(1)
end

sgcls

