#
# miss1.rb
#   $Id: miss1.rb,v 1.2 2000/11/18 19:03:40 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include NMath


NMAX = 40
XMIN = 0.0
XMAX = 4*PI
YMIN = -1.0
YMAX = 1.0

x = NArray.sfloat(NMAX+1)
y = NArray.sfloat(NMAX+1)

#-- data ----
dt = XMAX/NMAX
x = x.indgen * dt
y = sin(x)

n1 = NMAX/4
rmiss = glrget('RMISS')
y[n1-1] = rmiss
y[n1]   = rmiss
y[n1+1] = rmiss

n2 = n1*3
y[n2-1] = rmiss
y[n2+1] = rmiss

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws
grfrm

#-- default ----
grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt( 0.1,  0.9,  0.7,  0.9)
grstrn(1)
grstrf

sgplu(NMAX+1, x, y)

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt( 0.1,  0.9,  0.5,  0.7)
grstrn(1)
grstrf

sgspmt(3)
sgpmu(NMAX+1, x, y)

#-- cover loss data ----
gllset('LMISS', true)

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt( 0.1,  0.9,  0.3,  0.5)
grstrn(1)
grstrf

sgplu(NMAX+1, x, y)

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt( 0.1,  0.9,  0.1,  0.3)
grstrn(1)
grstrf

sgpmu(NMAX+1, x, y)

grcls

