#
# u2d4.rb
#
# $Id: u2d4.rb,v 1.1 2000/11/21 03:15:31 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include NMath


nx = 21
ny = 21
xmin = -10.0
xmax = 10.0
ymin = -10.0
ymax = 10.0
kmax = 5
pmin = 0.0
pmax = 1.0
dx = (xmax-xmin)/(nx-1)
dy = (ymax-ymin)/(ny-1)
dp = (pmax-pmin)/kmax

u = NArray.sfloat(nx, ny)
v = NArray.sfloat(nx, ny)
p = NArray.sfloat(nx, ny)


#-- data ----
for j in 0..ny-1
  for i in 0..nx-1
    xi = xmin + i*dx
    yj = ymin + j*dy
    u[i, j] = xi
    v[i, j] = -yj
    p[i, j] = exp(-xi**2/64 - yj**2/25)
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
sglset('LSOFTF', true)
grfrm

grswnd(xmin, xmax, ymin, ymax)
uspfit
grstrf

usdaxs
ugvect(u, nx, v, nx, nx, ny)
udcntr(p, nx, nx, ny)

for k in 0..kmax-1
  tlev1 = k*dp
  tlev2 = tlev1 + dp
  ipat  = 600 + k
  uestlv(tlev1, tlev2, ipat)
end

uetone(p, nx, nx, ny)

grcls

